﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.WindowsAzure;
using Microsoft.WindowsAzure.StorageClient;

namespace CopyAmazonObjectToBlobStorage
{
    class Program
    {
        private static string azureStorageAccountName = "<your target windows azure storage name>";
        private static string azureStorageAccountKey = "<your target windows azure storage account key>";
        private static string azureBlobContainerName = "<blob container where you wish to copy the vhd>";
        private static string amazonObjectUrl = "<URL of the blob in your source windows azure storage account>";
        private static string azureBlobName = "<name of the vhd file (with .vhd extension)>";
        static void Main(string[] args)
        {
            CloudStorageAccount csa = new CloudStorageAccount(new StorageCredentialsAccountAndKey(azureStorageAccountName, azureStorageAccountKey), true);
            CloudBlobClient blobClient = csa.CreateCloudBlobClient();
            var blobContainer = blobClient.GetContainerReference(azureBlobContainerName);
            Console.WriteLine("Trying to create the blob container....");
            //blobContainer.CreateIfNotExist();
            Console.WriteLine("Blob container created....");
            var blockBlob = blobContainer.GetBlockBlobReference(azureBlobName);
            Console.WriteLine("Created a reference for block blob in Windows Azure....");
            Console.WriteLine("Blob Uri: " + blockBlob.Uri.AbsoluteUri);
            Console.WriteLine("Now trying to initiate copy....");
            blockBlob.StartCopyFromBlob(new Uri(amazonObjectUrl), null, null, null);
            Console.WriteLine("Copy started....");
            Console.WriteLine("Now tracking blob's copy progress....");
            bool continueLoop = true;
            while (continueLoop)
            {
                Console.WriteLine("");
                Console.WriteLine("Fetching lists of blobs in Azure blob container....");
                var blobsList = blobContainer.ListBlobs(true, BlobListingDetails.Copy);
                foreach (var blob in blobsList)
                {
                    var tempBlockBlob = (CloudBlob) blob;
                    var destBlob = blob as CloudBlob;

                    if (tempBlockBlob.Name == azureBlobName)
                    {
                        var copyStatus = tempBlockBlob.CopyState;
                        if (copyStatus != null)
                        {
                            Console.WriteLine("Status of blob copy...." + copyStatus.Status);
                            var percentComplete = copyStatus.BytesCopied / copyStatus.TotalBytes;
                            Console.WriteLine("Total bytes to copy...." + copyStatus.TotalBytes);
                            Console.WriteLine("Total bytes copied...." + copyStatus.BytesCopied);
                            if (copyStatus.Status != CopyStatus.Pending)
                            {
                                continueLoop = false;
                            }
                        }
                    }
                }
                Console.WriteLine("");
                Console.WriteLine("==============================================");
                System.Threading.Thread.Sleep(1000);
            }

            Console.WriteLine("Process completed....");
            Console.WriteLine("Press any key to terminate the program....");
            Console.ReadLine();
        }
    }
}
